﻿	/************************************************************ 
	/ Auteurs : DELOISON Matthieu								/ 
	/ Fonction : Lecteur FLux RSS								/
	/															/
	/ Date de création : 01/12/2005  							/
	/ Date de mise à jour : 01/--/2005  						/ 
	************************************************************/


/* NOTES :
* 

*/
import com.delfiweb.utils.*;
import com.delfiweb.error.*;
import com.delfiweb.command.*;

/**
* Point d'entrée du programme, Compatible MTASC (MotionTwin ActionScript 2 Compiler)
* 
* @class PMain
* @author Claude François
* @version 0.1
*/
class PMain
{
	
	/*----------- Constantes des images ------------*/
	private var loadingQueue;
	
	
	/*----------- Composants de la scène ------------*/
	private static var _instance:PMain; 		// L'instance unique du singleton
	public var isLocal:Boolean; 				// Est-t'on en local ?
	public var isDebug:Boolean; 				// Active-t'on le debug ?
	private var _main:MovieClip; 				// Pointeur sur le niveau	
	private var _voile:MovieClip;				// Voile d'opacité
		
		
	/*----- Constantes ------*/
	private var _niveau:Number;				// la profondeur des movies clips		
	private var _niveauIMG:Number;				// la profondeur des movies clips		
	private var _idNews:Number;				// la profondeur des movies clips		
	private var _rss:Number;					// la profondeur des movies clips		
	public var _indexTab:Number;				// l'index du tableau qui contient les textes des flux RSS		
	private var _nbrActu:Number;				// le nbre d'actu affichées
	public var _cptXML:Number;					// le nbre d'actu affichées
	private var _parser;
	private var _mask:MovieClip;
	private var _contenuNews:MovieClip;
	private var _contenuNewsAff:MovieClip;
	private var _contenuNewsAffTitre:MovieClip;
	private var _bordureNews:MovieClip;
	private var _affCptVisites:Boolean;
	
	
	
	/*----- Gestion du Parser -----------*/
	private var _xml; 								// stock le noeud xml a envoyer		
	private var monXMLgen; 							// stock le noeud xml a envoyer			
	private var monXMLvisite; 					// stock le noeud xml a envoyer		

	
	/*----- Constantes K2000 ------*/
	private var _numDiode:Number;
	private var	_offsetX:Number;
	private var	_espaceEntre:Number;
	private var	_sens:Number;
	private var _niveauK:Number;
	
	private var	_tempo;
	private var	_tempo2;
	private var	_tempo3;
	
	
	/*----- Affichage de l'heure ------*/
	public var	days:Array;
	public var	months:Array;
	public var	timedate;
	
	
	/**
	* Constructeur privé, réalise la plupart des initialisations du programme, appelle ensuite
	* la méthode <b>_init</b> qui est la fonction de lancement autonome du programme, à utiliser
	* avec le PGameController
	* 
	* @method PMain 
	* @return Void
	*/
	private function PMain ()
	{
		// si le parametre version n'est pas transmis on est en local
		isLocal = (_root.version == undefined) ? true : false;		
		// si on est en local le debug est donc activé, sinon c'est en fonction du parametre php
		isDebug = (isLocal) ? true : ((_root.debug != undefined) ? true : false); 
		

		// on s'inscrit comme écouteur du diffuseur d'erreur
		ErrorDispatcher.addListener(this);
		
		// on stocke un pointeur sur le niveau
		_main = _root;
		
		isDebug = false;
		//isLocal = false;
		
		if(isLocal)
		{
			//trace("---- mode local ----")
			_root.txtdownload = "Chargement des fichiers xml en cours...";
			
			_root.urlFicXML = "matbe-news.xml,matbe-articles.xml,openfiles2.xml,linuxfr2.xml,";
			_root.urlFicXML += "openfiles.xml,linuxfr.xml,clubic.xml,"
			_root.urlFicXML += "pc-inpact.xml,presence-pc.xml,";
			_root.urlFicXML += "psp.xml,ratiatum.xml,gueux.be.xml,generation-nt.xml";
			
			_root.urlIMG = "images/terre2.png,images/clubic2.png,images/clubic3.png,images/clubic4.png,images/generation1.png,";
			_root.urlIMG += "images/generation2.png,images/generation3.png,images/generation4.png,images/internet-web-browser.png,";
			_root.urlIMG += "images/pcinpact1.png,images/pcinpact2.png,images/presencepc.png,images/ratiatum1.png,";
			_root.urlIMG += "images/ratiatum4.png,images/ratiatum.png";
			
			_root.alea = 1;
		}
		_affCptVisites = true;
		
	}
	
	/**
	* C'est le point d'entrée du programme, appelé sur la première image du fla,
	* elle est compatible MTASC
	* 
	* @usage	PMain.main()
	* @method 	static main
	* @return 	Void
	*/
	public static function main ()
	{
		if(_instance == undefined)
		{
			_instance = new PMain();
			_instance._init();
		}
	}
	
	/**
	* C'est la qu'on fera le vrai setup du programme, prévue pour une utilisation avec 
	* le nouveau Debugger
	* 
	* @usage 	PMain.instance._init()
	* @method 	_init
	* @return 	Void
	*/
	public function _init()
	{
		
		/*--- inbitialisation de toutes les variables ---*/	
		if(!_voile)
		{
			_parser = Parser.getInstance();
			_voile = _main.attachMovie("voile", "voile", 9000);
		}
		onVisibleChange(true);
		
		_root.attachMovie("background", "background", 3000,{_alpha:0});

		_main.attachMovie("tooltip","tooltip",300,{_x:-200});// alt sur les vignettes
		
		_main = _root.createEmptyMovieClip("contenair",_niveau++);
		
		
		
		_rss = _cptXML = 0;
		_niveau = 10;
		_niveauIMG = 1000;
		_niveauK = 3100;
		
		// les coordonnées de la news
		Constant.POSX = Constant.POSX1 = 20;
		Constant.POSY = Constant.POSY1 = 70;
		Constant.POSX2 = 460;
		_global.POSY1 = _global.POSY2 = 0;
		
		_idNews = _indexTab = 0;
		_nbrActu = 14;
		
		loadingQueue = new LoadStack ();
		loadingQueue.addListener (this);
		//_tempo3 = setInterval(this,"animFIN",8000);// 8s
		
		jouer ()
	}
		
		
		
	/**
	 *	Cette fonction lance tout d'abord la vérification
	 *  de doublon flash
	 * 
	 *	@usage		PMain.instance.jouer()
	 *	@method		jouer
	 *	@return		Void
	 */
	public function jouer ()
	{
		jouerOn ();
	}
	
	
	
	/**
	 *	>ette fonction lance tout d'abord la vérification
	 *  de doublon flash
	 * 
	 *	@usage		PMain.instance.jouer()
	 *	@method		jouer
	 *	@return		Void
	 */
	public function rejouer()
	{
		jouer();
	}
	
	
	
	/**
	 *	Appelé si aucune instance du flash n'existe 
	 * 
	 *	@usage		jouerOn()
	 *	@method		jouerOn
	 *	@return		Void
	 */
	public function jouerOn ()
	{	
		/*--- Décode le fichier XML ---*/
		monXMLvisite = new XML();
		monXMLvisite.ignoreWhite = true;
		monXMLvisite.onLoad = function()
		{
			PMain.instance._parser.parseXML (PMain.instance.monXMLvisite)
		}
		if(isLocal) monXMLvisite.load("strings.xml");
		else monXMLvisite.load(_root.urlXML+"?killcache="+Math.floor(Math.random()*100));

	}
	
			
	
	// fonction lance la construction du lecteur (après le parse des Strings)
	public function contructOn()
	{
		_global.RSS = new Array();
		persoMenu();
		copyright();
		construireTableauXML();
		construireTableauIMG();
		loadXML();
	}
	
	
	
	/**
	* @property instance (PMain) L'instance unique de la classe PMain (read-only)
	*/
	public static function get instance ():PMain
	{
		return _instance;
	}
	
	
	
	/*--------------------------------------------------------------------------*/
	/*------------- Chargement des fichiers XML ------------------------------*/
	/*--------------------------------------------------------------------------*/
	
	
	/**
	* Récupère les évènements de l'ErrorDispatcher afin de les diffusés on de gérer les
	* exceptions du programme.
	*
	* @method onError
	* @param e (Error) 		Un objet Error
	*/
	function onError (e)
	{

	}
		
	// fonction : charge les fichiers xml
	function loadXML()
	{
		// parcours du tableaucontenant tous les fichiers xml

		monXMLgen = new XML();
		monXMLgen.ignoreWhite = true;
		monXMLgen.onLoad = function()
		{
			PMain.instance._parser.parseXMLrss(PMain.instance.monXMLgen,PMain.instance._cptXML)
		}
		
		var aleatoire = 10 * random(1500);
		var nomTemp:Number = random(25);
		
		if(isLocal) monXMLgen.load(Constant.urlFicXML[_cptXML]);// on lance le chargement
		else monXMLgen.load(Constant.urlFicXML[_cptXML]+"?cacheKill"+nomTemp+"="+aleatoire);// on lance le chargement
		
		_cptXML++;
		
	}
	
	
	
	
	
	
	/*----------------------------------------------------------*/
	/*---------------- Mise en page ----------------------------*/
	/*----------------------------------------------------------*/
	
	// affiche le compteur de visite
	function affVisite(texte)
	{
		_main.attachMovie("visites","visites",_niveau++,{_x:30, _y:_global.POSY})
		_main.visites.contenu = texte;
	}
	
	// fonction : mise en page des news
	function afficher(numNews:Number)
	{		
		_contenuNews = _main.attachMovie("bordure2","contenuNews"+numNews,_niveau++,{_x:Constant.POSX,_y:Constant.POSY})
		_bordureNews = _main.attachMovie("bordure","bordureNews"+numNews,_niveau++,{_x:Constant.POSX,_y:Constant.POSY})

		
		_contenuNews._y = Constant.POSY;
		_bordureNews._y = Constant.POSY;

		
		_contenuNewsAff = _contenuNews.attachMovie("titreSite","titreSite"+numNews,_niveau++,{_x:20, _y:10})

		var coordX:Number = 10;
		var coordY:Number = 50;
		var cpt2:Number = 0;
		
		for(var cpt=0; cpt< _global.RSS.length; cpt++)
		{
			
			
			if(_global.RSS[cpt].id == numNews && cpt2 <_nbrActu)
			{
				cpt2++;
				//trace("titreSite RSS: "+_global.RSS[cpt].titreSite)
				_contenuNewsAff.contenu = "<center><u>"+_global.RSS[cpt].titreSite+"</u></center>";
	
				_contenuNewsAffTitre = _contenuNews.attachMovie("titreNews","titreNews"+numNews+cpt,_niveau++,{_x:coordX, _y:coordY})
				
				_contenuNewsAffTitre.description.wordWrap = false;
				_contenuNewsAffTitre.contenu =  _global.RSS[cpt].dateNews+"  <font color='#000000'>"+_global.RSS[cpt].titreNews+"</font>";
				_contenuNewsAffTitre.onRelease = Delegate.create(PMain.instance,_onNewsClik,_global.RSS[cpt].urlNews).getFunction();

				_contenuNewsAffTitre.onRollOver = Delegate.create(PMain.instance,_onRollover,numNews,cpt).getFunction();
				_contenuNewsAffTitre.onRollOut = Delegate.create(PMain.instance,_onRollout,numNews,cpt).getFunction();
				
				//_main["bordure"+numNews]["titreNews"+numNews+cpt].description.autoSize = false;
				_contenuNewsAffTitre.description._width = 365;
				_contenuNewsAffTitre.description._height = 30;
				coordY += 20;
			}
			
		}
		_bordureNews._height = coordY + 10;
		
		addIMG(Constant.POSX, Constant.POSY); // ajout d'un logo
		
		
		var posxActu:Number = Constant.POSX;
		
		if(posxActu == Constant.POSX1)
		{
			Constant.POSX = Constant.POSX2;
			_global.POSY1 = _bordureNews._height + 20;
			_global.POSY = Constant.POSY;
			
		}
		else
		{
			_global.POSY2 = _bordureNews._height + 20;
			Constant.POSX = Constant.POSX1;
			_global.POSY = Constant.POSY+ _bordureNews._height+10;
			
		}
		
		
		if(posxActu == Constant.POSX2)
		{
			if(_global.POSY1 > _global.POSY2) Constant.POSY += _global.POSY1;
			else Constant.POSY += _global.POSY2;
		}
		
		_global.POSY = Constant.POSY;
		
		
		if(_cptXML<Constant.urlFicXML.length)	loadXML();
		else animFIN();
		
		
		
	}
		
		
	
	// entrée : les coordonnées approximative du logo
	// fonction : ajoute une icone à coté de la news	
	function addIMG(coordX:Number, coordY:Number)
	{
		_main.createEmptyMovieClip("IMGlogo"+_cptXML, _niveauIMG++ );
		
		_main["IMGlogo"+_cptXML]._x = coordX+5;
		_main["IMGlogo"+_cptXML]._y = coordY+5;

		
		
		if(_root.alea == 0) loadingQueue.loadClip (Constant.urlIMG[_cptXML], _main["IMGlogo"+_cptXML]);
		else
		{
			var Num:Number = random(Constant.urlIMG.length-1); // pour 5 --> 0,1 --> 4;

			loadingQueue.loadClip (Constant.urlIMG[Num], _main["IMGlogo"+_cptXML]);
		}
	}
	
	
	function _onNewsClik(urlNews)
	{
		var command = new AppelURLCommand (urlNews,"_blank", "GET", {}).execute();
		command.execute ();
	}

	// entrée : le clip, le texte
	function _onRollover(entree)
	{
		
		entree = entree.toString();
		var temp:Array = entree.split(",");	// 0 -> numNews -- 1 -> cpt
		var numeroNews:Number = temp[0];
		var cptNews:Number = temp[1];
		
		if(_global.RSS[cptNews].description != undefined)
		{
			var tempStr:String = new ReplaceString (_global.RSS[cptNews].description).arrayReplace (["<br>","<br />","&lt;br /&gt;","&eacute;","&rsquo;","&ccedil;"], ["\n","\n","\n","é","'","ç"] );
			tempStr= new ReplaceString (tempStr).arrayReplace (["&lt;acronym title=&quot;","&quot;&gt;NdM&lt;/acronym&gt;","&lt;i&gt;","&lt;/i&gt;","&lt;ul&gt;","&lt;li&gt;","&lt;/ul&gt;","&lt;/li&gt;","&lt;b&gt;","&lt;/b&gt;","&lt;a href=&quot;","&lt;/a&gt;","&quot;&gt;","&quot; target=&quot;_blank&quot;&gt;"], [" "," "," "," "," "," "," "," "," "," "," "," "," "," "] );
			_root.tooltip.onOver (tempStr, _main["contenuNews"+numeroNews]["titreNews"+numeroNews+cptNews]);

		}
			
		_main["contenuNews"+numeroNews]["titreNews"+numeroNews+cptNews].contenu = "<font color='#9933ff'>"+_global.RSS[cptNews].dateNews+"  </font><b><font color='#0066ff'>"+_global.RSS[cptNews].titreNews+"</font></b>";
	}

	// entrée : le clip, le texte
	function _onRollout(entree)
	{
		_root.tooltip.onOut();
		entree = entree.toString();
		var temp:Array = entree.split(",");	// 0 -> numNews -- 1 -> cpt
		var numeroNews:Number = temp[0];
		var cptNews:Number = temp[1];
		
		_main["contenuNews"+numeroNews]["titreNews"+numeroNews+cptNews].contenu = _global.RSS[cptNews].dateNews+"  <font color='#000000'>"+_global.RSS[cptNews].titreNews+"</font>";
	}
	
	
	/*--------------------------------------------------------------------------*/
	/*----------------------- Images des news ----------------------------------*/
	/*--------------------------------------------------------------------------*/
		
	function onLoadStart ()
	{
		
	}
	
	
	function onLoadProgress()
	{
		
	}
	
	
	function onLoadComplete()
	{
		
		//onVisibleChange(false);
	}
	
	
	function onLoadError()
	{
		//trace("erreur de chargement")
	}
	
	
	/*--------------------------------------------------------------------------*/
	/*---------------------------- Effets --------------------------------------*/
	/*--------------------------------------------------------------------------*/
	
	
	// fonction : effectue les animations de fin
	function animFIN()
	{
		loadingQueue.startLoad ();
		/*--- compteur de visite ---*/
		if(!isLocal && _affCptVisites)
		{
			monXMLvisite = new XML();
			monXMLvisite.ignoreWhite = true;
			monXMLvisite.onLoad = function()
			{
				PMain.instance.affVisite(PMain.instance.monXMLvisite)
			}
			
			var aleatoire = 10 * random(1500);
			var nomTemp:Number = random(25);
			monXMLvisite.load(Constant.CPT_VISITES+"?cacheKill"+nomTemp+"="+aleatoire);// on lance le chargement
			
		}
		


		/*--- intégration d'une scrollbarre ---*/
		_mask = _root.attachMovie("maskNews","mask",108,{_y:60, _visible:false})
		_main.setMask(_mask);
		_root.attachMovie("PScrollbar","scroller",110,{_x:880, _y:60, docked:false, _targetClip:_main, _wheelClip:_mask})
		_root.scroller._visible = _mask._visible = true;
		
		affTitre();
		
		PMain.instance.onVisibleChange(false);
		
		// la date
		new mx.transitions.Tween (_root.titreFlux, "_x" ,mx.transitions.easing.Bounce.easeIn, 900, 85, 2, true )	
			
	}


	/*----------------------------------------------------------*/
	/*------------- Gestion du titre -------------------------*/
	/*----------------------------------------------------------*/
	
	
	// fonction : affiche l'heure en temps réel
	function affTitre()
	{
		
		_root.attachMovie("date","date",_niveau++,{_x:123, _y:15,_visible:false})
		_root.attachMovie("date","titreFlux",_niveau++,{_x:130, _y:15})
		_root.titreFlux.contenu = _global.Strings[20];
		
	}
		
		
		
	
	/*----------------------------------------------------------*/
	/*------------- Copyright ----------------------------------*/
	/*----------------------------------------------------------*/
	
	
	// fonction : lien sur mon Book
	function copyright()
	{
		_root.attachMovie("auteur","auteur", 5020 ,{_x:820,_y:670})
		_root.attachMovie("auteurOver","auteurOver", 5023 ,{_x:820,_y:670, _visible:false})
		//_root.auteur.contenu = "Auteur";
		//_root.auteurOver.contenu = "Auteur";
		_root.auteur._alpha = 80;
		_root.auteurOver._alpha = 0;
		_root.auteurOver.onRelease = Delegate.create(this,_onBtnReleaseAuteur).getFunction();
		_root.auteur.onRollOver = Delegate.create(this,_onBtnReleaseAuteurRollOver).getFunction();
		_root.auteurOver.onRollOut = Delegate.create(this,_onBtnReleaseAuteurRollOut).getFunction();
		
	}
	
	function _onBtnReleaseAuteur()
	{
		// redirection sur le site
		var obj:Object=""; 
		var command = new AppelURLCommand ("http://matthieu.deloison.free.fr","_blank", "GET", {}).execute();
		command.execute ();
	}
	
	function _onBtnReleaseAuteurRollOver()
	{
		_root.auteur._alpha = 0;
		_root.auteurOver._alpha = 80;
		_root.auteurOver._visible = true;
	}
	
	
	function _onBtnReleaseAuteurRollOut()
	{
		_root.auteur._alpha = 80;
		_root.auteurOver._alpha = 0;
		_root.auteurOver._visible = false;
	}
	
	// fonction : personnalisation du menu flash
	function persoMenu()
	{
		//trace("perso menu")
		Stage.showMenu = true;
		var menuPerso:ContextMenu = new ContextMenu()

		menuPerso.hideBuiltInItems(); // cacher le menu d'origine
		
		var m1:ContextMenuItem = new ContextMenuItem("Auteur", Delegate.create(PMain.instance,_mail).getFunction())
		//var m2:ContextMenuItem = new ContextMenuItem("Book", function(){})
		
		//m2.separatorBefore = true;// insérer une séparation
		
		menuPerso.customItems = [m1];
		//menuPerso.customItems = [m1,m2];
		_root.menu = menuPerso; // mettre à jour le menu
	}
	
	
	// fonction : personnalisation du menu flash - contact me
	function _mail() 
	{
		new AppelURLCommand ("http://matthieu.deloison.free.fr","_blank", "GET", {nocache:random(100000)}).execute();		
	}
	
	
	/*----------------------------------------------------------*/
	/*------------- Divers -------------------------------------*/
	/*----------------------------------------------------------*/
	
	
	
	
	// fonction : permet de masquer le voile en fonction de la PDiag
	function onVisibleChange (b)
	{
		
		_voile._visible = b;
		if (b)
		{
			_root.attachMovie("loadertxt","loadertxt",9100,{_x:300,_y:260});
			_root.attachMovie("affk2000","affk2000",9101,{_x:495,_y:285});
			_voile.useHandCursor = false;
			//_root.loadertxt.contenu = _global.Strings[1];
			_root.loadertxt.contenu = _root.txtdownload;
			_voile._alpha = 100;
			_voile.onRelease = function ()
			{
			};
		} 
		else
		{
			_voile.useHandCursor = false;
			_root.loadertxt.removeMovieClip();
			_root.affk2000.removeMovieClip();
			delete _voile.onRelease
		}

	}
	

	// fonction : construire le tableau des urls des fichiers XML
	function construireTableauXML():Void
	{
		var converter:ArrayConverter = new ArrayConverter (",");
		var a :Array = converter.convert (_root.urlFicXML);
		
		var b:Array = new Array();
		var lastType = -1;
		var i =0;
		
		for(i in a)
		{
			if(Constant.urlFicXML[i] = a[i] != lastType )
			{					   
				var obj = Constant.urlFicXML[i] = a[i];
				b.push(obj);
				lastType = Constant.urlFicXML[i]= a[i];
			}
		}
		Constant.urlFicXML = b;
	}
	
	
	// fonction : construire le tableau des images
	function construireTableauIMG():Void
	{
		var converter:ArrayConverter = new ArrayConverter (",");
		var a :Array = converter.convert (_root.urlIMG);
		
		var b:Array = new Array();
		var lastType = -1;
		var i =0;
		
		for(i in a)
		{
			if(Constant.urlIMG[i] = a[i] != lastType )
			{					   
				var obj = Constant.urlIMG[i] = a[i];
				b.push(obj);
				lastType = Constant.urlIMG[i]= a[i];
			}
		}
		Constant.urlIMG = b;
	}
	
	
}// fin de la classe