﻿import com.delfiweb.error.*;


/*
@class com.delfiweb.error.ErrorDispatcher
@version 1.1
@author Cédric Néhémie
description :  Le recepteur statique d' erreurs, agit comme un objet 
			 observable, a l'aide du pattern _Observable
*/
class com.delfiweb.error.ErrorDispatcher implements _ErrorDispatcher
{
	
	private static var _lastError:_DelfiwebError;// la dernière erreur enregistrée
	private static var _ecouteurs:Array = new Array();// le tableau des écouteurs
	private static var _changed:Boolean = false;// le marqueur d'etat 

	
	/*
	entrée :  e (DError) l'erreur a transmettre
	description :  la méthode principale de délégation d'erreur
	*/
	public static function send (e:DError):Void
	{
		_lastError = e;
		notifyListeners("onError");
	}
	
	
	// implementation _Observable
	public static function addListener (o:Object):Void
	{
		for(var i in _ecouteurs)
		{
			if(o == _ecouteurs[i])
			{
				return;
			}
		}
		_ecouteurs.push(o);
	}
	
	
	// on enlève un listener
	public static function removeListener (o:Object):Void
	{
		for(var i in _ecouteurs)
		{
			if(o == _ecouteurs[i])
			{
				_ecouteurs.splice(Number(i),1);
			}
		}
	}
	
	
	// on notifie le changement à tous les listeners d'un évènement
	private static function notifyListeners (en:String):Void
	{
		setChanged ();
		for(var i in _ecouteurs)
		{
			if(_ecouteurs[i][en])
			{
				_ecouteurs[i][en](_lastError);
			}
		}
		clearChanged ();
	}
	
	
	// permet a la classe ainsi qu'a des classes extèrieure de connaitre
	// l'état de modification de la classe écoutée
	private static function setChanged ():Void
	{
		_changed = true;
	}
	
	
	private static function clearChanged ():Void
	{
		_changed = false;
	}
	
	
	public static function hasChanged ():Boolean
	{
		return _changed;
	}	
}
